=== tests/CMakeLists.txt ===

add_subdirectory(common)


foreach (CURRENT_BACKEND IN LISTS SOCI_ENABLED_BACKENDS)
  string(TOUPPER "${CURRENT_BACKEND}" CURRENT_BACKEND_UPPER)
  string(TOLOWER "${CURRENT_BACKEND}" CURRENT_BACKEND_LOWER)

  set(SOCI_${CURRENT_BACKEND_UPPER}_SKIP_TESTS OFF CACHE BOOL "Whether to skip tests for backend '${CURRENT_BACKEND}'")

  if (NOT SOCI_${CURRENT_BACKEND_UPPER}_SKIP_TESTS)
    add_subdirectory(${CURRENT_BACKEND_LOWER})
  endif()
endforeach()
