=== debian/changelog ===
soci (4.1.2-1) unstable; urgency=medium

  * New upstream version 4.1.2, Closes: 1113525
  * Refresh patches
  * Update Standards Version (no changes)
  * Do not attempt to install .a files, since they are no longer built
  * Add .cmake files to dev package
  * Clean additional files. Closes: 1045590

 -- William Blough <bblough@debian.org>  Sun, 19 Oct 2025 13:10:13 -0400
