=== debian/tests/control ===
Tests: build
Depends:
 build-essential,
 libsoci-dev,
 libboost-dev,
 default-libmysqlclient-dev,
 firebird-dev,
 libpq-dev,
 libsqlite3-dev,
 unixodbc-dev
